config/routes.rb
Rails.application.routes.draw do

  get 'donationsmanager/menu'
  get 'donationsmanager/thanks'
  devise_for :users, controllers: { registrations: 'registrations'}
  root to: 'app#home'

  resources :profiles, only: [:show, :edit, :update], shallow: true do
    resources :images, except: :show
    resources :accounts, except: :show
    resources :beverages, only: [:new, :create]
  end

end

app/models/account.rb
class Account < ApplicationRecord
  belongs_to :profile
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/beverage.rb
class Beverage < ApplicationRecord
  belongs_to :profile
  has_one :donation, as: :donable
end

app/models/donation.rb
class Donation < ApplicationRecord
  belongs_to :donable, polymorphic: true
end

app/models/image.rb
class Image < ApplicationRecord
  belongs_to :profile
  has_one_attached :photo
end

app/models/profile.rb
class Profile < ApplicationRecord
  belongs_to :user
  has_one_attached :avatar
  has_many :accounts
  has_many :images
  has_many :beverages
  # has_many :hugs
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_one :profile
end

app/controllers/accounts_controller.rb
class AccountsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_profile, only: [:index, :new, :create]
  before_action :set_account, only: [:edit, :update, :destroy]

  before_action :check_current_user, only: [:index, :new]

  def index
    @accounts = @profile.accounts
  end

  def new
    @account = Account.new
  end

  def create
    @account = @profile.accounts.build(account_params)
    if @account.save
      redirect_to profile_accounts_path(@profile), notice: 'Account was successfully created.'
    else
      render :new
    end
  end

  def edit
  end

  def update
    @profile = @account.profile.id
    if @account.update(account_params)
      redirect_to profile_accounts_path(@profile), notice: 'Your info was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @profile = @account.profile.id
    @account.destroy
    redirect_to profile_accounts_path(@profile), notice: 'Info was successfully destroyed.'
  end

  private

  def set_profile
    @profile = Profile.find(params[:profile_id])
  end

  def set_account
    @account = Account.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def account_params
    params.require(:account).permit(:bank, :kind, :account_number, :email, :cedula)
  end
end

app/controllers/app_controller.rb
class AppController < ApplicationController
  def home
  end
end

app/controllers/beverages_controller.rb
class BeveragesController < ApplicationController
  def new
    @profile = Profile.find(params[:profile_id])
    @beverage = Beverage.new
  end

  def create
    @profile = Profile.find(params[:profile_id])
    @beverage = @profile.beverages.build({quantity: params[:beverage][:quantity]})
    if @beverage.save
      @beverage.build_donation({
        occupation: params[:beverage][:occupation],
        message: params[:beverage][:message],
        contributor: params[:beverage][:contributor],
      }).save
      redirect_to donationsmanager_thanks_path(@profile), notice: 'Thank you for your donation!'
    else
      render :new
    end
  end
end

app/controllers/images_controller.rb
class ImagesController < ApplicationController
  before_action :authenticate_user!
  before_action :set_profile, only: [:index, :new, :create]
  before_action :set_image, only: [:edit, :update, :destroy]

  before_action :check_current_user, only: [:index, :new]

  def index
    @images = @profile.images
  end

  def new
    @image = Image.new
  end

  def create
    @image = @profile.images.build(image_params)
    if @image.save
      redirect_to profile_images_path(@profile), notice: 'image was successfully created.'
    else
      render :new
    end
  end

  def edit

  end

  def update
    @profile = @image.profile.id
    if @image.update(image_params)
      redirect_to profile_images_path(@profile), notice: 'Your info was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @profile = @image.profile.id
    @image.destroy
    redirect_to profile_images_path(@profile), notice: 'Info was successfully destroyed.'
  end

  private

  def set_profile
    @profile = Profile.find(params[:profile_id])
  end

  def set_image
    @image = Image.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def image_params
    params.require(:image).permit(:subtitle, :public, :photo)
  end
end

app/controllers/profiles_controller.rb
class ProfilesController < ApplicationController
  before_action :authenticate_user!, only: [:edit, :update]
  before_action :set_profile, only: [:edit, :update, :show]

  before_action :check_current_user, only: [:edit, :update]

  before_action :sort_me, only: [:update]

  def edit
  end

  def update
    if @profile.update(profile_params)
      @profile.update({
        m1: @multipliers[0],
        m2: @multipliers[1],
        m3: @multipliers[2],
        m4: @multipliers[3]
      })
      redirect_to edit_profile_path(@profile.id), notice: 'YES EDITED'
    else
      render :edit
    end
  end

  def show
  end

  private

  def sort_me
    @multipliers = []
    @multipliers << params[:profile][:m1].to_i
    @multipliers << params[:profile][:m2].to_i
    @multipliers << params[:profile][:m3].to_i
    @multipliers << params[:profile][:m4].to_i
    @multipliers.sort!
  end

  def set_profile
    @profile = Profile.find(params[:id])
  end

  def check_current_user
    if current_user.id != @profile.id
      redirect_to root_path
    end
  end

  def profile_params
    params.require(:profile).permit(:fullname, :bio, :occupation, :amount, :currency, :m1, :m2, :m3, :m4, :avatar)
  end
end

app/helpers/accounts_helper.rb
module AccountsHelper
end

app/helpers/app_helper.rb
module AppHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/beverages_helper.rb
module BeveragesHelper
end

app/helpers/donationsmanager_helper.rb
module DonationsmanagerHelper
end

app/helpers/images_helper.rb
module ImagesHelper
end

app/helpers/profiles_helper.rb
module ProfilesHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/views/app/home.html.haml
.home_mobile
  .home_header
    .home_rectangle
    .home_login_button
    -if current_user
      = link_to 'Logout',               destroy_user_session_path, method: :delete, class: 'home_login'
    -else
      = link_to 'Login', new_user_session_path, class: 'home_login'
    .home_underline
    .home_login_temp
    .home_rectangle3
    =link_to 'A&C', root_path, class: 'home_ac'
  .home_hero
    .home_bg
    .home_content
    .home_button
    .home_rectangle2
    -unless current_user
      = link_to 'Crear mi perfil', new_user_registration_path, class: 'home_register'
    -else
      =link_to 'Ir a mi perfil', edit_profile_path(current_user.profile), class: 'home_register'
    .home_info Recibe aprecio y gratitud mediante donaciones online
    .home_slogan Un café es un abrazo atrapado en una taza
    .home_coffees
      %img{:src => "assets/coffees/coffees.svg"}/

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{:content => "text/html; charset=UTF-8", "http-equiv" => "Content-Type"}/
    %title AbrazosCafeApp
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload'
    = javascript_include_tag 'application', 'data-turbolinks-track': 'reload'

  %body
    = yield

app/views/shared/_admin_nav.html.haml
.navbar
.background
.profile
.profile_data
=link_to current_user.profile.fullname, profile_path(current_user.profile), class: 'profile_name'
.profile_avatar
=link_to 'A&C', root_path

- begin
  =image_tag(current_user.profile.avatar)
- rescue
  %p no image yet


%hr

=link_to 'Perfil', edit_profile_path(current_user.profile)
=link_to 'Imagenes', profile_images_path(current_user.profile)
=link_to 'Cuentas', profile_accounts_path(current_user.profile)

-# =link_to 'Back', :back
%hr

app/views/shared/_public_nav.html.haml
- begin
  =image_tag(@profile.avatar)
- rescue
  %p no image yet

%br
=link_to @profile.fullname, profile_path(@profile)
%p= @profile.occupation


=link_to 'A&C', root_path
%hr

app/views/shared/_sessions_nav.html.haml
%p THIS IS THE LAYOUTS NAVIGATION : ONLY SESSIONS HERE
-if current_user
  = link_to 'Sign out', destroy_user_session_path, method: :delete
-else
  = link_to 'Sign in', new_user_session_path
  = link_to 'Sign up', new_user_registration_path
%hr